

using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
	///<summary>
	/// 阅片计划
	///</summary>
	[Table("ReadingPeriodPlan")]
	public class ReadingPeriodPlan : Entity, IAuditAdd, IAuditUpdate, ISoftDelete
	{

		/// <summary>
		/// 阅片期配置ID
		/// </summary>
		public Guid ReadingPeriodSetId { get; set; }

		/// <summary>
		/// 访视
		/// </summary>
	    public Guid SubjectVisitId { get; set; }

		/// <summary>
		/// 访视
		/// </summary>
		[ForeignKey("SubjectVisitId")]
		[JsonIgnore]
		public SubjectVisit SubjectVisit { get; set; }

		/// <summary>
		/// 阅片期配置
		/// </summary>
		[ForeignKey("ReadingPeriodSetId")]
		[JsonIgnore]
		public ReadingPeriodSet ReadingPeriodSet { get; set; }

		/// <summary>
		/// 创建时间
		/// </summary>
		public DateTime CreateTime { get; set; }

		/// <summary>
		/// 创建人
		/// </summary>
		public Guid CreateUserId { get; set; }

		public Guid UpdateUserId { get; set; }
	
		public DateTime UpdateTime { get; set; }




		public bool IsDeleted { get; set; }

		public DateTime? DeletedTime { get; set; }

		public Guid? DeleteUserId { get; set; }

	}



}
