

using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
	///<summary>
	/// 阅片期和中心关联
	///</summary>
	[Table("ReadingPeriodSite")]
	public class ReadingPeriodSite : Entity, IAuditAdd
	{

		/// <summary>
		///阅片期配置ID
		/// </summary>
		
		public Guid ReadingPeriodSetId { get; set; }

		/// <summary>
		/// 项目ID
		/// </summary>
		public Guid TrialId { get; set; }

		/// <summary>
		/// 中心ID
		/// </summary>
		public Guid SiteId { get; set; }

		/// <summary>
		/// 创建时间
		/// </summary>
		public DateTime CreateTime { get; set; }

		/// <summary>
		/// 创建人
		/// </summary>
		public Guid CreateUserId { get; set; }


		/// <summary>
		/// 中心
		/// </summary>
		public Site Site { get; set; }



		public TrialSite TrialSite { get; set; }

		[JsonIgnore]
		public ReadingPeriodSet ReadingPeriodSet { get; set; }


	}






}
