﻿namespace IRaCIS.Core.Infrastructure.Extention
{
    /// <summary>
    /// 响应数据输出接口
    /// </summary>
    public interface IResponseOutput
    {
        /// <summary>
        /// 是否成功
        /// </summary>
        bool IsSuccess { get; }

        public ApiResponseCodeEnum Code { get; set; }

        /// <summary>
        /// 消息
        /// </summary>
        string ErrorMessage { get; }
    }

    /// <summary>
    /// 响应数据输出泛型接口
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public interface IResponseOutput<T> : IResponseOutput
    {
        /// <summary>
        /// 返回数据
        /// </summary>
        T Data { get; }
    }

    //public interface IResponseOutput<T,T2> : IResponseOutput
    //{
    //    /// <summary>
    //    /// 返回数据
    //    /// </summary>
    //    T Data { get; }

    //    T2 OtherInfo { get; }
    //}
}
